#include <iostream>
#include <stdio.h>
#include <math.h>
#include "polylib.h"

/*
To compile (in same directory as polylib.c and polylib.h):
g++ -c polylib.c
g++ -c exercise2a.cpp
g++ -o exercise2a exercise2a.o polylib.o
*/

using namespace std;
using namespace polylib;

double *dvector(int np);
double **dmatrix(int n);
void *func(int np, double *z, double *p);
void *diff(int np, double **D, double*p, double *pd);

main()
{
  int np=8;
  double *w,*z,*p,*pd,**D,**Dt;

  /* set up vectors and matrices */
  z = dvector(np);
  w = dvector(np);
  p = dvector(np);
  pd = dvector(np);
  D = dmatrix(np);
  Dt = dmatrix(np);

  /* get zeros and weights */
  zwgll(z, w, np);

  /* get differentiation matrix D */
  Dgll(D, Dt, z, np);

  /* calculate p=z^7 at np points z */
  func(np, z, p);

  /* differentiate p and put result in pd */
  diff(np, D, p, pd);

  /* generate output */
  cout << "\n  ksi\n\n";
  for(int i=0;i<np;i++){
    cout << z[i] << "\n";
  }cout << "\n\n du/dksi\n\n";
  for(int i=0;i<np;i++){
    cout << pd[i] << "\n";
  }cout << "\n";
}

double *dvector(int n)
{
  double *v;

  v = (double *)malloc(n*sizeof(double));
 return v;
}

double **dmatrix(int n)
{
  double **A;
  A = (double **)malloc(n*sizeof(double *));
  A[0] = (double *)malloc(n*n*sizeof(double));

  for(int i=1;i<n;i++){
    A[i] = A[i-1]+n;
  }
  return A;
}

void *func(int np, double *z, double *p)
{
  register int pow=7;

  for(int i=0;i<np;i++){
    p[i] = 1;
    for(int j=0;j<pow;j++){
      p[i] = p[i]*z[i];
    }
  }
}

void *diff(int np, double **D, double*p, double *pd)
{
  for(int i=0;i<np;i++){
    pd[i] = 0;
    for(int j=0;j<np;j++){
      pd[i] = pd[i] + D[i][j]*p[j]; 
    }
  }
}
